# $Id dicshunary.sql/1.1.1.1/Sun Jul  7 12:17:09 2002//
#
# Table structure for table 'definitions'
#

CREATE TABLE definitions (
  def_id int(11) NOT NULL auto_increment,
  def_text text NOT NULL,
  word_id int(11) default NULL,
  rating int(10) default NULL,
  rudeness int(2) NOT NULL default '1',
  date_added date NOT NULL default '0000-00-00',
  PRIMARY KEY  (def_id)
) TYPE=MyISAM;

#
# Table structure for table 'issues'
#

CREATE TABLE issues (
  issue_id int(11) NOT NULL auto_increment,
  issue_name varchar(20) NOT NULL default '',
  issue_desc text NOT NULL,
  start_date date NOT NULL default '0000-00-00',
  image_src varchar(100) default NULL,
  is_open int(11) NOT NULL default '1',
  rudeness int(10) default '1',
  PRIMARY KEY  (issue_id)
) TYPE=MyISAM;

#
# Table structure for table 'ratings'
#

CREATE TABLE ratings (
  rating_id int(11) NOT NULL auto_increment,
  user_id int(11) NOT NULL default '0',
  word_id int(11) NOT NULL default '0',
  PRIMARY KEY  (rating_id)
) TYPE=MyISAM;

#
# Table structure for table 'relations'
#

CREATE TABLE relations (
  rel_id int(11) NOT NULL auto_increment,
  word_id int(11) default NULL,
  def_id int(11) default NULL,
  issue_id int(11) default NULL,
  user_id int(11) default NULL,
  usage_id int(11) default NULL,
  PRIMARY KEY  (rel_id)
) TYPE=MyISAM;

#
# Table structure for table 'sites'
#

CREATE TABLE sites (
  site_id int(11) NOT NULL auto_increment,
  issue_id int(11) NOT NULL default '0',
  user_id int(11) NOT NULL default '0',
  site_html text NOT NULL,
  your_site_url varchar(150) NOT NULL default '',
  date_added date NOT NULL default '0000-00-00',
  PRIMARY KEY  (site_id)
) TYPE=MyISAM;

#
# Table structure for table 'user'
#

CREATE TABLE user (
  user_id int(11) NOT NULL auto_increment,
  user_name varchar(100) default NULL,
  real_name varchar(200) default NULL,
  email varchar(100) default NULL,
  password varchar(50) default NULL,
  remote_addr varchar(30) default NULL,
  confirm_hash varchar(50) default NULL,
  is_confirmed int(2) NOT NULL default '0',
  is_admin int(1) NOT NULL default '0',
  likes_rudeness int(1) NOT NULL default '0',
  PRIMARY KEY  (user_id)
) TYPE=MyISAM;

#
# Dumping data for table 'user'
#

INSERT INTO user VALUES (1,'admin',' Admin User','you@yoursite.com','25e4ee4e9229397b6b17776bfceaf8e7','1.1.1.1','7b14b6c821cf8198c5329513dfce0ce6',1,1,1);
INSERT INTO user VALUES (3,'guest',' Guest User','you@yoursite.com','0fb9cbecb7b8881511c69c39db643e8c','1.1.1.1','7b14b6c821cf8198c5329513dfce0ce6',1,0,0);


#
# Table structure for table 'word_of_day'
#

CREATE TABLE word_of_day (
  word_id int(11) NOT NULL default '0',
  date_chosen date NOT NULL default '0000-00-00',
  rudeness int(2) NOT NULL default '1',
  PRIMARY KEY  (word_id)
) TYPE=MyISAM;

#
# Table structure for table 'words'
#

CREATE TABLE words (
  word_id int(11) NOT NULL auto_increment,
  word_text varchar(100) NOT NULL default '',
  rating int(10) default NULL,
  rudeness int(2) NOT NULL default '1',
  date_added date NOT NULL default '0000-00-00',
  in_main char(3) default 'yes',
  PRIMARY KEY  (word_id)
) TYPE=MyISAM;


