<?php

/***************************************************************************  
 *                              edit_issues.php
 *                            -------------------                         
 *   begin                : Tuesday 8th May 2002 
 *   copyright            : (C) 2002 Saul Albert      
 *   email                : code@dicshunary.com                          
 *                                                          
 *   $Id: /edit_issues.php/1.1.1.1/Sun Jul  7 12:17:09 2002//
 *                                                            
 * 
 ***************************************************************************/ 

define('IN_DICSHUNARY', true);
$dicshunary_root_path = './';

include_once($dicshunary_root_path.'common.inc');
include_once($dicshunary_root_path . 'check_status.php');

// only allow this to continue if the user owns the issue.
if (dic_user_has_issues()) {
  $header=site_header($lang[change_your_issue]);
} else {
  // otherwise, redirect them to the "add an issue" page
  header("Location:add_issue.$phpEx");
}

// if the user has submitted something, try adding it.
if ($submit) {
  // add the issue to the db
  dic_add_or_alter_issue($issue_name,$issue_desc,$image_src,$issue_id, $is_open, $rudeness_rating);
} elseif ($delete) {
  // delete the issue from the db
  dic_delete_issues($issue_id);
} elseif ($remove_word) {
  // delete this word form this issue
  dic_delete_word_from_issue($word_id, $issue_id);
}

$content.= '<h1>'.$lang[alter_your_issues].'</h1>'; 


if ($issue_id && dic_is_issue_owner($issue_id)) {
  $context='edit_issues'; // HACK !(so that the option to remove words is active in print_dic() )
  $content.=dic_print_user_issue($issue_id);
} elseif (empty($issue_id) && dic_user_has_issues()) {
  $content.=dic_print_user_issues_menu();
} else {
  $feedback.=$lang[not_logged_in_or_no_issues];
}

// give some feedback to the user - good or bad
if ($feedback) {
  $content.= '<span class="feedback">'.stripslashes($feedback).'</span><br>';
}

$site_footer = site_footer();

include_once($dicshunary_root_path . '/templates/default.tpl');
?>