<?php
/***************************************************************************  
 *                             dic_functions.php
 *                            -------------------                         
 *   begin                : Thurs 25th April 2002 
 *   copyright            : (C) 2002 Saul Albert      
 *   email                : code@dicshunary.com                          
 *                                                          
 *   $Id: /dic_functions/1.1.1.1/Sun Jul  7 12:17:09 2002//
 *                                                            
 * 
 ***************************************************************************/ 



function dic_print_add_to_issue_select($with_main) {
  // with main is set to 1 or 0 - if 1 we get a list with the 
  // main dictionary at the top and after all issue entries
  // if not 1 we just get a list of issues.
  global $feedback, $site_url, $dicshunary_root_path, $lang, $rudeness, $installation;

  $user_id = user_getid();
  // get user's rudeness from cookie
  if($rudeness!= "rude") {
    $rudeness_limit = 'AND rudeness < 1';
  }
  $sql="SELECT DISTINCT issues.issue_id, issue_name, user_id FROM issues, relations WHERE issues.issue_id = relations.issue_id  AND relations.user_id > 0 AND ((is_open = '1' OR is_open = '2') OR (user_id = $user_id)) $rudeness_limit";
  $result=db_query($sql);
  $nb= db_numrows($result);
  $row=0;
  
  if ($nb > 0) { // There are some issues, print them out.
    
    $return='<SELECT name=issue_id>';
    if ($with_main == 1) {
      $return.='<option value="">'.$lang[just_the_main_dictionary].'</option>';
    }
    
    while ($row < $nb) { 
      $issue_id = db_result($result,$row,'issue_id');
      $issue_name = db_result($result,$row,'issue_name');
      // hack! - but not such a bad one
      if(strtoupper($issue_name) == strtoupper($installation)) {
	$return.="<option value=\"$issue_id\" SELECTED>$issue_name";
      } else {
	$return.="<option value=\"$issue_id\">$issue_name";
      }
      
      if ($with_main == 1) {
	$return.=" $lang[as_well]";
      }
      $return.="</option>";
      
      $row++;
    }
    
  } else { 
    return false;
  }
  $return.='</SELECT>';
  return $return;
  
}

function dic_get_word_id($word_text) {
  global $G_DIC_RESULT;
  //see if we have already fetched this word from the db, if not, fetch it
  if (!$G_DIC_RESULT) {
    $G_DIC_RESULT=db_query("SELECT word_id FROM words WHERE word_text='$word_text'");
  }
  if ($G_DIC_RESULT && db_numrows($G_DIC_RESULT) > 0) {
    return db_result($G_DIC_RESULT,0,'word_id');
  } else {
    return false;
  }
}


function dic_get_word_text($word_id) {
  global $G_W_T_RESULT;
  //see if we have already fetched this from the db, if not, fetch it
  if (!$G_W_T_RESULT) {
    $G_W_T_RESULT=db_query("SELECT word_text FROM words WHERE word_id='$word_id'");
  }
  if ($G_W_T_RESULT && db_numrows($G_W_T_RESULT) > 0) {
    return db_result($G_W_T_RESULT,0,'word_text');
  } else {
    return false;
  }
}



function dic_get_def_id($def_text) {
  global $G_DIC_DEF_RESULT;
  //see if we have already fetched this definition from the db, if not, fetch it
  if (!$G_DIC_DEF_RESULT) {
    $G_DIC_DEF_RESULT=db_query("SELECT def_id FROM definitions WHERE def_text='$def_text'");
  }
  if ($G_DIC_DEF_RESULT && db_numrows($G_DIC_DEF_RESULT) > 0) {
    return db_result($G_DIC_DEF_RESULT,0,'def_id');
  } else {
    return false;
  }
}

function dic_get_issue_id($issue_name) {
  global $G_ISS_RESULT;
  //see if we have already fetched this issue from the db, if not, fetch it
  if (!$G_ISS_RESULT) {
    $G_ISS_RESULT=db_query("SELECT issue_id FROM issues WHERE issue_name='$issue_name'");
  }
  if ($G_ISS_RESULT && db_numrows($G_ISS_RESULT) > 0) {
    return db_result($G_ISS_RESULT,0,'issue_id');
  } else {
    return false;
  }
}

function dic_get_issue_name($issue_id) {
  global $G_I_N_RESULT;
  //see if we have already fetched this from the db, if not, fetch it
  if (!$G_I_N_RESULT) {
    $G_I_N_RESULT=db_query("SELECT issue_name FROM issues WHERE issue_id='$issue_id'");
  }
  if ($G_I_N_RESULT && db_numrows($G_I_N_RESULT) > 0) {
    return db_result($G_I_N_RESULT,0,'issue_name');
  } else {
    return false;
  }
}

function dic_word_is_in_issue($word_id, $issue_id) {
  global $G_I_I_RESULT;
  //see if we have already fetched this from the db, if not, fetch it
  if (!$G_I_I_RESULT) {
    $G_I_I_RESULT=db_query("SELECT word_id FROM relations WHERE word_id='$word_id' AND issue_id = '$issue_id'");
  }
  if ($G_I_I_RESULT && db_numrows($G_I_I_RESULT) > 0) {
    return true;
  } else {
    return false;
  }
}


function dic_get_issue_rules($issue_id) {
 global $G_I_R_RESULT;
  //see if we have already fetched this from the db, if not, fetch it
  if (!$G_I_R_RESULT) {
    $G_I_R_RESULT=db_query("SELECT is_open FROM issues WHERE issue_id='$issue_id'");
  }
  if ($G_I_R_RESULT && db_numrows($G_I_R_RESULT) > 0) {
    return db_result($G_I_R_RESULT, '0', 'is_open');
  } else {
    return false;
  }
}

function dic_get_email_from_user_id($user_id) {
  $sql = "SELECT email FROM user WHERE user_id = '$user_id'";
  $result=db_query($sql);
  $email=db_result($result,'0','email');
  if ($email) {
    return $email;
  } else {
    return false;
  }
}

function dic_mail_issue_owner_request($word_id, $issue_id) {
  // ignore commented out debugging stuff. I will remove this at some point
  global $dicshunary_root_path, $lang, $site_url, $phpEx, $admin_email, $feedback;
  // first we need the owner_id
  $user_id = dic_get_issue_owner($issue_id);
  // $feedback.="issue_id = $issue_id |";
  // now we need the owner_email
  $user_email = dic_get_email_from_user_id($user_id);
  // $feedback.="email = $user_email |";
  // now we get the word text
  $word_text = dic_get_word_text($word_id);
  // $feedback.="word_text = $word_text |";
   // now we get the issue name
  $issue_name = dic_get_issue_name($issue_id);
  //  $feedback.="issue_name = $issue_name |";
 
  // now we send the mail 
  $message = "$lang[someone_added]".
       "\n\n \"$word_text\" \n\n".
     "$lang[to_your_issue] \"$issue_name\"  \n\n".
     "$lang[remove_by_visiting_this_url]".
           "\n $site_url".
       "edit_issues.$phpEx?remove_word=true&word_id=$word_id&issue_id=$issue_id&email_remove=true \n\n".
     "$lang[or_do_nothing_to_accept]: ".
     "\n\n -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-\n$lang[email_response_issue_disclaimer]\n\n".
     "$site_url"."edit_issues.$phpEx?issue_id=$issue_id";

   mail ($user_email,$lang[request_to_add_to_issue].' '.$issue_name,$message,"From: $admin_email");
   // $feedback.="sent email to $user_email |";
  return true;
  
  
}

function dic_add_word_to_issue($issue_id, $word_id) {
  global $lang, $feedback, $email_remove;

  if ($issue_id && !dic_word_is_in_issue($word_id, $issue_id)) {

    // if the dicshunary is closed, or the owner wants email requests
    // just send an email to the owner or deny the request.
    $issue_rules = dic_get_issue_rules($issue_id);
    if ($issue_rules == 0 && !dic_is_issue_owner($issue_id)) {
      $feedback.=$lang[you_are_not_authorized];
      return false;
    } else {
      if ($issue_rules == 2 && !dic_is_issue_owner($issue_id)) {
	// if the owner asked to alterts, mail them. (issue_rules == 2)
	dic_mail_issue_owner_request($word_id, $issue_id);
      }
      // insert relationship between word and issue
      $sql="INSERT INTO relations (word_id, issue_id)".
	 "VALUES ('$word_id','$issue_id')";
      $result=db_query($sql);
      if (!$result) {
	$feedback .=' ERROR -'.db_error();
	return false;
      } else {
	$feedback.=$lang[your_word_was_added_to].' "'.dic_get_issue_name($issue_id).'". ';
	
	return true;
      }
    }
  } else {
    if ($issue_id) {
      // if an issue id is actually set the if above failed on !dic_word_is_in_issue
      // that means some meaningful feedback would be useful
      $feedback.=$lang[that_word_is_already_in].' '.dic_get_issue_name($issue_id).'. ';
    }
    return false;
  }
}

function dic_send_add_text_email($text, $text_id,$user_id, $text_type, $rudeness_rating) {
  global $dicshunary_root_path, $lang, $site_url, $phpEx,$admin_email, $new_words_notify;
  /*
		When a word is added, an email is sent to an admin to ask them
		to come and rate it.
		$text type lets us know whether we are rating an issue name, 
		a word or a definiton
  */
  if ($new_words_notify == 'true') {
    $message = "$lang[text_has_been_added].[ = $rudeness_rating ??]".
       "\n $lang[please_rate_the_text] : $text \n\n".
       "$lang[rate_as_polite]: ".
       "\n $site_url".
       "rate.$phpEx?".$text_type."_id=$text_id&text_owner_id=$user_id&rating=polite \n\n".
       "$lang[rate_as_rude]: ".
       "\n $site_url".
       "rate.$phpEx?".$text_type."_id=$text_id&text_owner_id=$user_id&rating=rude";
    mail ($admin_email,$lang[text_has_been_added],$message,"From: $admin_email");
  }
}

function dic_add_word($word_text,$def_text,$issue_id,$in_main,$rudeness_rating) {
  
  global $feedback, $site_url, $dicshunary_root_path, $lang;
  
  if (empty($rudeness_rating)) {
    $rudeness_rating = 0;
  }
  
  // Get user_id if possible
  $user_id = user_getid();
  
  // strip html from word_text
  $word_text = strip_tags($word_text);
  $word_text = str_replace('<!--', '', $word_text);
  
  // and from defninition
  $def_text = strip_tags($def_text);
  $def_text = str_replace('<!--', '', $def_text);
  
  //all absolutely necessary vars present and correct?
  if ($word_text && $def_text) {
    
    //
    // Insert words/definitions
    //
    
    //does the word exist?
    $sql="SELECT * FROM words WHERE word_text='$word_text'";
    $result=db_query($sql);
    if ($result && db_numrows($result) > 0) {
      // if it does, redefine it instead of adding it to words table again, and change feedback
      $redef=1;
    }
    
    
    // only add the word if it's not been added before, otherwise, just define etc.
    if ($redef != 1)	{
      //insert the new word into the dicshunary (in_main defaults to "yes" unless it's set to nout).
      if (!isset($in_main)) {
	$in_main = "yes";
      }
      $sql="INSERT INTO words (word_text,rating,rudeness,date_added,in_main) ".
	 "VALUES ('$word_text','0','$rudeness_rating',now(),'$in_main')";
      $result=db_query($sql);
      if (!$result) {
	$feedback .= ' ERROR - '.db_error();
				return false;
      } 
      // clear the result so we can get useful error if next db op fails.
      unset($result);
    } 
    
    // get the word_id of the word we just inserted
    if ($word_id=dic_get_word_id($word_text)) {
      // send an email to an admin to rate the word
      if ($redef!=1) {
	dic_send_add_text_email($word_text, $word_id, $user_id, 'word', $rudeness);
      }
    }
    
    //does the definition exist for that word already? (a resubmission on redefinition)
    $sql="SELECT * FROM definitions, words WHERE def_text='$def_text' AND definitions.word_id = '$word_id'";
    $result=db_query($sql);
    if ($result && db_numrows($result) > 0) {
      // if it does, throw an appropriate error
      $feedback .= "$lang[definition_exists]";
      return false;
    }
    
    // insert definition into dicshunary
    $sql="INSERT INTO definitions (def_text, word_id, rating, rudeness ,date_added) ".
       "VALUES ('$def_text','$word_id','0','$rudeness_rating',now())";
    $result=db_query($sql);
    if (!$result) {
      $feedback .=' ERROR -'.db_error();
      return false;
    } 
    unset($result);
    
    
    // get the def_id of the definition we just inserted
    if ($def_id=dic_get_def_id($def_text)) {
      // send an email to an admin to rate the word
      dic_send_add_text_email($def_text, $def_id, $user_id, 'def', $rudeness);
    }
    
    
    //
    // Insert relevant relations
    //
    
    dic_add_word_to_issue($issue_id, $word_id);
    
    // only insert word authorship relation if the user is logged in, we have an id and we're not redefining
    if (!empty($user_id) && $redef != 1 ) {
      // insert user_id and word_id in authorship so we know who created the word
      $sql="INSERT INTO relations (word_id, user_id) ".
	 "VALUES ('$word_id','$user_id')";
      $result=db_query($sql);
      if (!$result) {
	$feedback .=' ERROR -'.db_error();
	return false;
      } 
      unset($result);
    }
    
    // now we insert the definition relation information (again only if we have a user_id)
    if ($user_id) {
      // insert user_id and word_id in authorship so we know who created the word
      $sql="INSERT INTO relations (def_id, user_id) ".
	 "VALUES ('$def_id','$user_id')";
      $result=db_query($sql);
      if (!$result) {
	$feedback .=' ERROR -'.db_error();
	return false;
      } 
      unset($result);
    }
    
    // now give appropriate feedback
    if ($redef==1) {
      $feedback .= "$lang[thank_you_for_redefining] $lang[the_word] \"$word_text\" ";
    } else {
      $feedback .= "$lang[thanks_for_adding] \"$word_text\" $lang[to_the_dictionary]";
    }
    return true;
    
    
  } else {
    $feedback .=  "$lang[error_no_word_or_definition]";
    return false;
  }
}

function dic_display_info($type, $var_a, $var_b){
  global $lang;
  // this function gets useful information for types of dicshunary
  if($type == 'issue') {
    $sql="SELECT issue_name, issue_desc, image_src FROM issues WHERE issue_id = '$var_a'";
    $result=db_query($sql);
    $issue_name = db_result($result,'0','issue_name');
    $issue_desc = db_result($result,'0','issue_desc');
    $image_src = db_result($result,'0','image_src');
    $dic_title.="<h2>$issue_name</h2>\n\n";
    if ($image_src) {
      $dic_title.="<img src=\"http://$image_src\">";
    }
    $dic_title.="<p><i>$issue_desc</i></p>\n";
    return $dic_title;
  } elseif ($type=='date') {
    $dic_title.="<h2>$lang[words_entered_into_the_dictionary_in] ".dic_monthname($var_a).", $var_b</h2>";
    return $dic_title;
  } elseif ($type=='user') {
    $sql="SELECT user_name FROM user where user_id = '$var_a'";
    $result=db_query($sql);
    $user_name = db_result($result,'0','user_name');
    $dic_title.="<h2>$lang[words_entered_by] $user_name</h2>\n\n";
    $dic_title.="<p><i>$lang[here_are_your_words]</i></p>\n";
    return $dic_title;
  } elseif ($type=='a-z') {
    $dic_title.="<h2>$lang[words_beginning_with] \"".strtoupper($var_a)."\"</h2>";
    return $dic_title;
  } else { // type == everything or text only
    // show how many words, the first date and the current date.
    $sql="SELECT dayname(date_added) as day, dayofmonth(date_added) as date, monthname(date_added) as month, year(date_added) as year FROM words ORDER BY date_added ASC LIMIT 1";
    $result=db_query($sql);
    $day = db_result($result,'0','day');
    $date = db_result($result,'0','date');
    $month = db_result($result,'0','month');
    $year = db_result($result,'0','year');
    $date_added = "<b>$day, $date $month, $year</b>";
    $sql="SELECT count(word_id) as number FROM words";
    $result=db_query($sql);
    $number_of_words = db_result($result,'0','number');
    $dic_title.="<h2>$lang[the_whole_dictionary]</h2>\n\n";
    $dic_title.="<p><i>$lang[All] $number_of_words $lang[words_in_the_dictionary] $lang[since] $date_added</i></p>\n";
    return $dic_title;
  }
}


function dic_monthname($month) {
  $monthname[]='';
  $monthname[]='January';
  $monthname[]='February'; 
  $monthname[]='March'; 
  $monthname[]='April'; 
  $monthname[]='May'; 
  $monthname[]='June'; 
  $monthname[]='July'; 
  $monthname[]='August'; 
  $monthname[]='September'; 
  $monthname[]='October';
  $monthname[]='November';
  $monthname[]='December';
  return $monthname[$month];
}

function dic_print() {
  // notice the NASTY HACK with $context here... this should be removed in the next release
  global $feedback, $site_url, $dicshunary_root_path, $month, $year, $issue_id, $lang, $user_id, $rudeness, $mode, $context, $letter;
  
  include($dicshunary_root_path.'common.inc');
  
  // get user's rudeness from cookie
  if($rudeness!= "rude" && $politeness_method=='hide') {
    $rudeness_limit = 'AND words.rudeness < 1 AND definitions.rudeness < 1';
  }
  
  // if there's an issue we only choose those words, otherwise we default to the whole dictionary
  if ($issue_id) {
    // if we're dealing with an issue, first get the issue information
    $printout.=dic_display_info('issue', $issue_id, '');
    $sql="SELECT words.word_id, word_text, definitions.def_id, def_text, definitions.rudeness as def_rudeness, words.rudeness as word_rudeness FROM words, definitions, relations WHERE words.word_id = definitions.word_id AND relations.word_id = words.word_id AND relations.issue_id = '$issue_id' $rudeness_limit ORDER BY word_text";
  } elseif ($month && $year) {
    // if we're dealing with a date issue, first get the date
    $printout.=dic_display_info('date', $month, $year);
    $sql="SELECT words.word_id, word_text, def_id, def_text, definitions.rudeness as def_rudeness, words.rudeness as word_rudeness  FROM words, definitions WHERE words.word_id = definitions.word_id AND month(words.date_added) = '$month' and year(words.date_added) = '$year' $rudeness_limit ORDER BY word_text";
  } elseif ($user_id) {
    // make sure people can't see each others word lists
    if (!user_isadmin()) {
      if ($user_id != user_getid()) {
	return $lang[you_are_not_allowed_to_see_that];
	exit;
      }
    }
    // if we're dealing with a user issue, first get user info
    $printout.=dic_display_info('user', $user_id, '');
    $sql="SELECT words.word_id, word_text, definitions.def_id, def_text, definitions.rudeness as def_rudeness, words.rudeness as word_rudeness FROM words, definitions, relations WHERE words.word_id = definitions.word_id AND relations.word_id = words.word_id AND user_id = '$user_id' $rudeness_limit ORDER BY word_text";
  } elseif (!empty($letter)) {
    $printout.=dic_display_info('a-z', $letter, '');
    $sql="SELECT words.word_id, word_text, def_id, def_text, definitions.rudeness as def_rudeness, words.rudeness as word_rudeness  FROM words, definitions WHERE words.word_id = definitions.word_id AND LEFT(word_text,1)='$letter' $rudeness_limit ORDER BY word_text"; 

  } else {
    // we are printing the whole dicshunary
    $printout.=dic_display_info('everything', '', '');
    
    $sql="SELECT words.word_id, word_text, def_id, def_text, definitions.rudeness as def_rudeness, words.rudeness as word_rudeness  FROM words, definitions WHERE words.word_id = definitions.word_id $rudeness_limit ORDER BY word_text";
  }
  
  
  $result=db_query($sql);
  $nb= db_numrows($result);
  $row=0;
  
  
  
  if ($nb > 0) { // There are some words in the dicshunary
    
    while ($row < $nb) {  
      
      $word_id = db_result($result,$row,'word_id');
      $word_text = db_result($result,$row,'word_text');
      $def_id = db_result($result,$row,'def_id');
      $def_text = db_result($result,$row,'def_text');
      $def_rudeness= db_result($result,$row,'def_rudeness');
      $word_rudeness= db_result($result,$row,'word_rudeness');
      
      // print out the index letters (a-z)
      $first_letter=substr($word_text,0,1);
      
      // if the first letter is not alphabetical, set the $non_alpha variable
      // below we add non alpha words to a separate list ($non_alpha_list) and then
      // append it to the end of the list once all the alphabetical words have been printed.
      if (!ereg ("[a-zA-Z]", $first_letter)) {
	$non_alpha=1;
      }
      
      
      if ($mode=='admin' && user_isadmin()) {
	$word_links = " - [<a href=\"delete_entries.$phpEx?word_id=$word_id\">$lang[del]</a>] ";
	$def_links = " - [<a href=\"delete_entries.$phpEx?def_id=$def_id\">$lang[del]</a>] ";
	if ($word_rudeness == 0) {
	  $word_links.= "[ <a href=\"rate.$phpEx?word_id=$word_id&rating=rude\"> $lang[rude]</a> ]";
	} else {
	  $word_links.= "[ <a href=\"rate.$phpEx?word_id=$word_id&rating=polite\"> $lang[polite]</a> ]";
	}
	if ($def_rudeness == 0) {
	  $def_links.= "[ <a href=\"rate.$phpEx?def_id=$def_id&rating=rude\"> $lang[rude]</a> ]";
	} else {
	  $def_links.= "[ <a href=\"rate.$phpEx?def_id=$def_id&rating=polite\"> $lang[polite]</a> ]";
	}
      }
      // notice the NASTY HACK - $context = 'edit_issues' this should be fixed properly soon.
      if (!empty($issue_id) && dic_is_issue_owner($issue_id) && !user_is_guest() && $context=='edit_issues') {
	$word_links = " - [ <a href=\"$PHP_SELF?remove_word=true&word_id=$word_id&issue_id=$issue_id\">$lang[remove]</a> ]";
      }
      
      
      if ($last_word_id != $word_id && !empty($word_id)) {
	
	if ($dic_nav_links) {
	  $word_list.="</ul>\n\n";
	}
	
	if (strtoupper($prev_first_letter) != strtoupper($first_letter)) {
	  
	  if (!isset($dic_nav_links)) {
	    // dic_nav_links isn't set - this is the first loop - so no back to top link.
	    $word_list.="</div><div class=\"section\"><h2>$first_letter</h2>\n\n";
	    // set it with a | so it looks nice later
	    $dic_nav_links='| ';
	  } else {
	    $word_list.="<a name=\"$first_letter\"><div align=\"right\"><a href=\"#top\">$lang[back_to_top]</a></div></div><div class=\"section\"><h2>$first_letter</h2>\n\n";
	  }
	  
	  $dic_nav_links.='<a href="#'.strtoupper($first_letter).'">'.strtoupper($first_letter).'</a> | ';
	} elseif ($non_alpha ==1) {
	  $word_list.="<h2>$lang[others]</h2>\n\n";
	}
	
	// if we are censoring words... 
	// get user's rudeness from cookie
	if($rudeness!= "rude" && $politeness_method=='censor' && $word_rudeness == 1) {
	  $word_list.='<b><span class="feedback">'.$lang[censored].'</span></b> -  [<a href="http://dicshunary.com/rudeness.'.$phpEx.'?set_rudeness=show_me_the_filth">'.$lang[unsensor].']</a><ul>';
	} else {
	  // urlencode word_text
	  $url_word_text = urlencode($word_text);

	  // another nasty hack to make sites work here, get rid of this later.
	  global $in_sites, $site_id;
	  if (empty($in_sites)) {
	    $link_to=$site_url."word_options.php?word_text=$url_word_text";
	  } else {
	    $link_to=$site_url."view_sites.php?site_id=$site_id&word_text=$url_word_text#form";
	  }


	  $word_list.="\n<b><a href=\"".$link_to."\" alt=\"$lang[options_for] $word_text\">$word_text</a></b>\n\n $word_links <ul>";
	}
      }
      
      if(!empty($def_text)) {
	if($rudeness!= "rude" && $politeness_method=='censor' && $def_rudeness == 1) {
	  $word_list.='<li><span class="feedback">'.$lang[censored].'</span> - <a href="http://dicshunary.com/rudeness.'.$phpEx.'?set_rudeness=show_me_the_filth">['.$lang[unsensor].']</a></li>';
	} else {
	  $word_list.='<li>'.$def_text.$def_links.'</li>';
	}
      }
      
      if($non_alpha !=1){
	$alpha_list.=$word_list;
      } else {
	$non_alpha_list.=$word_list;
      }
      
      $last_word_id = $word_id;
      $prev_first_letter = $first_letter;
      unset($non_alpha, $word_list);
      
      $row++; 
    }	
    
    // if we're printing out anything other than an alphabetical list we print out only the letters we got in the list:
    // now add the anchor nav bar to the top of $printout.
    if (empty($letter)) {
      $printout.='</div><div class="section" align="center"><a name="top">'.$dic_nav_links.'</div>'; 
    } else {
      $printout.='</div><div class="section" align="center"><a name="top">'.dic_print_alpha_list().'</div>';
    }
    
    if($alpha_list) {
      $printout.=$alpha_list;
    }
    
    if($non_alpha_list) {
      $printout.=$non_alpha_list;
    }
    
    
    $printout.='</ul><div align="right"><a href="#top">'.$lang[back_to_top].'</a></div>';
    
    
    return $printout;
    return true;
    
  } else {
    // There are no words in the dicshunary, say so.
    // but if rudeness is set, there are just no "polite" w
    if ($rudeness != 'rude') {
      return $lang[no_polite_words_in_dict];
    } else {
      return $lang[no_words_in_dict];
    }
  }
}


function dic_delete_words($word_id) {
  global $lang, $feedback;
  if (user_isadmin()) {
    // delete all definitions for this word
    if (dic_delete_words_definitions($word_id)) {
      $feedback.='the definitions of this word were deleted | ';
      // delete the words relations
      if(dic_delete_relations($word_id, 'word_id')) {
	$feedback.='the relations of the word were deleted | ';
	// delete the word itself
	// first, it has to be an array for dic_delete_entries function, even if it's only got one entry:
	$word_id_array[]=$word_id;
	if (dic_delete_entries($word_id_array,'words','word_id')) {
	  return true;
	} else {
	  $feedback.=$lang[the_word_was_not_deleted];//.' line 496 |';
	  return false;
	}
      } else {
	$feedback.=$lang[the_relations_were_not_deleted];//.' line 500 |';
	return false;
      }
    } else {
      $feedback.=$lang[the_word_definitions_were_not_deleted];//.' line 504 |';
      return false;
    }
  } else {
    $feedback.=$lang[you_are_not_authorized];//.' line 508 |';
    return false;
  }
}

function dic_delete_words_definitions($word_id) {
  global $feedback, $lang;
  // get an array of all the definitions of that word
  $def_id_array=dic_get_delete_array($word_id, 'definitions', 'word_id', 'def_id');
  // delete the relations for each definition
  if (dic_delete_entries($def_id_array, 'relations', 'def_id')) {
    // now delete all definitions for this word
    // first, make an array out of the word_id we've got
    $word_id_array[]=$word_id;
    // now we can pass it to dic_delete_entries() which only deals with arrays.
    if (dic_delete_entries($word_id, 'definitions', 'word_id')) {
      return true;
    } else {
      $feedback.=$lang[the_definitions_were_not_deleted];//.' line 523 |';
      return false;
    }
  } else {
    $feedback.=$lang[the_relations_were_not_deleted];//.' line 527 |';
    return false;
  }
}

function dic_delete_words_relations($word_id) {
  global $feedback, $lang;
  $sql = "DELETE FROM relations WHERE word_id = '$word_id'";
  $result=db_query($sql);
  if ($result) {
    $feedback.='the words relations were deleted';
    return true;
  } else {
    $feedback.='the words relations were not deleted';
    return false;
  }
}

function dic_delete_issues($issue_id) {
  global $feedback, $lang;
  if (!user_is_guest() && (user_isadmin() || dic_is_issue_owner($issue_id))) {
    // delete relation
    if (dic_delete_relations($issue_id, 'issue_id')) {
      // delete issue
      // first make it into an array
      $issue_delete_array[]=$issue_id;
      dic_delete_entries($issue_delete_array, 'issues','issue_id');
      $feedback.=$lang[the_issue_was_deleted];
      return true;
    } else {
      $feedback.=$lang[the_relations_were_not_deleted];//.' line 541 |';
      return false;
    }
  } else {
    $feedback.=$lang[you_are_not_authorized];//.' line 545 |';
    return false;
  }
}

function dic_delete_definitions($def_id) {
  global $lang, $feedback;
  if (user_isadmin()) {
    // select other defs and throw error if this is the only definition of a word.
    // first get the word_id for this def_id.
    $sql="SELECT word_id FROM definitions WHERE def_id = '$def_id' ";
    $result=db_query($sql);
    $word_id = db_result($result, '0', 'word_id');
    // now select all def_ids for this word.
    $sql="SELECT def_id FROM definitions WHERE word_id = '$word_id' ";
    $result=db_query($sql);
    $nb= db_numrows($result);
    if ($nb < 2) {
      // there is only one (or no) more definitions for this word, so thow an error
      $feedback.=$lang[there_is_only_one_definition_for_this_word];
      return false;
    } else {
      // delete relations for this definition
      if (dic_delete_relations($def_id, 'def_id')) {
	// delete the thing itself
	// first turn the def_id into an array so it can be passed
	// to dic_delete_entries  
	$def_id_array[]=$def_id;
	dic_delete_entries($def_id_array, 'definitions','def_id');
	return true;
      } else {
	$feedback.=$lang[the_relations_were_not_deleted];//.' line 573 |';
	return false;
      }
    } 
  } else {
    $feedback.=$lang[you_are_not_authorized];//.' line 578 |';
    return false;
  }
}

function dic_delete_relations($source_col_id, $source_colname) {
  global $feedback, $lang;
  // get an array of relations to delete
  if ($rel_id=dic_get_delete_array($source_col_id, 'relations', $source_colname, 'rel_id' )) {
    // pass the array to the delete function
    dic_delete_entries($rel_id, 'relations', 'rel_id');
    return true;
  } else {
    $feedback.=$lang[could_not_get_delete_array];//.' line 591 |';
    return false;
  }
}

// dic_get_delete_array($word_id, 'definitions', 'word_id', 'def_id');
function dic_get_delete_array($source_col_id, $tablename, $source_colname, $colname) {
  global $lang, $feedback;
  // select for delete
  $sql="SELECT $colname FROM $tablename WHERE $source_colname = '$source_col_id'";
  $result=db_query($sql);
  $nb= db_numrows($result);
  $row=0;
  if ($nb > 0) { // There are some results
    while ($row < $nb) {  
      $col_id = db_result($result,$row,"$colname");
      $col_id_array[]= $col_id;
      $row++; 
    }
    // pass the array back to the delete function
    return $col_id_array;
  } else {
    $feedback.=$lang[could_not_get_delete_array];//.' line 612 |';
    return false;
  }
}



//dic_delete_entries($word_id_array,'words','word_id');

function dic_delete_entries($col_id_array, $tablename, $colname) {
  
  // this function takes a numerically sorted array of ids, 
  // names them with $colname and deletes them from $tablename.
  
  global $lang, $feedback;
  
  // make sure that an empty attempt to delete doesn't open a database connection
  if (!empty($col_id_array) && !empty($tablename) && !empty($colname)) {
    // loop through selected items to find out which ones to delete
    $number=count($col_id_array);
    for ($a=0; $a<$number; $a++){
      // delete the thing itself from the dictionary
      $sql="DELETE FROM $tablename where $colname='$col_id_array[$a]'";
      $result=db_query($sql);
      if (!$result) {
	$feedback .= ' ERROR - '.db_error();
	return false;
      } else {
	return true;
      }
    }
  } else {
    $feedback.='<br>'.$lang[there_was_nothing_to_delete].'<br>';
    return false;
  }
}


function dic_print_date_selector($type, $limit_number) {
  
  global $lang, $feedback, $phpEx, $rudeness;
  // there is no limit if $limit_number is set to 0
  if ($limit_number > 0) {
    $limit = "LIMIT $limit_number";
  } else {
    unset($limit);
  }
  
  if ($rudeness != 'rude') {
    $rudeness_limit = 'WHERE rudeness < 1';
  }
  
  
  $sql="SELECT DISTINCT monthname(date_added) AS monthname, month(date_added) AS month, year(date_added)".
     "AS year FROM words $rudeness_limit ORDER BY date_added desc $limit";
  $result=db_query($sql);
  $nb= db_numrows($result);
  $row=0;
  
  if ($nb > 0) { // There are some months and years
    
    if ($type == 'select') {
      $printout="<SELECT NAME=\"monthyear\">";
    }
    
    while ($row < $nb) {  
      
      $monthname = db_result($result,$row,"monthname");
      $month = db_result($result,$row,"month");
      $year = db_result($result,$row,"year");
      if ($type == 'select') {
	$printout.="<OPTION value=\"$month, $year\"> $monthname, $year </OPTION>";
      } else {
	$printout.="- <a href=\"view_dict.$phpEx?month=$month&year=$year\">$monthname, $year</a><br>";
      }
      
      $row++; 
    }
    
    if ($type == 'select') {
      $printout.="</SELECT>";
    }
    
    return $printout;
    
  } else {
    // There are no words in the dicshunary, say so.
    if ($rudeness != 'rude') {
      return $lang[no_polite_words_in_dict];
    } else {
      return $lang[no_words_in_dict];
    }
    
    return false;
  }
}

function dic_get_issue_owner($issue_id) {
    
  $sql="SELECT user_id FROM relations WHERE issue_id = '$issue_id' AND user_id > 0";
  $result=db_query($sql);
  $nb=db_numrows($result);
  
  if ($nb > 0 ) {
    $user_id = db_result($result,'0','user_id');
    return $user_id;
  } else {
    return false;
  }

}


function dic_is_issue_owner($issue_id) {
  
  $user_id=user_getid();
  
  $sql="SELECT user_id FROM relations WHERE issue_id = '$issue_id' AND user_id = '$user_id'";
  $result=db_query($sql);
  $nb=db_numrows($result);
  
  if ($nb > 0 ) {
    return true;
  } else {
    return false;
  }
  
}


function dic_user_has_issues() {
  
  $user_id=user_getid();
  $sql="SELECT * FROM relations WHERE user_id = '$user_id' AND issue_id > 0";
  $result=db_query($sql);
  $nb=db_numrows($result);
  
  if ($nb > 0 ) {
    return true;
  } else {
    return false;
  }
  
}


function dic_print_user_issues_menu() {
  global $lang;
  $user_id=user_getid();
  
  // select the user's issues
  $sql="SELECT issues.issue_id, issue_name FROM issues, relations WHERE issues.issue_id = relations.issue_id AND relations.user_id = '$user_id'";
  $result=db_query($sql);
  $nb= db_numrows($result);
  $row=0;
  
  if ($nb > 0) { // This user owns some issues, print them out.
    
    while ($row < $nb) {  
      
      $issue_id = db_result($result,$row,"issue_id");
      $issue_name = db_result($result,$row,"issue_name");
      
      $printout.= "<li><A HREF=\"$PHP_SELF?issue_id=$issue_id\">$issue_name</A></li>\n";
      
      $row++; 
    }
    
    return $printout;
    
  } else {
    // There are no issues for this user
    $feedback.= "$lang[no_issues_for_this_user]";
    return false;
  }
}

function dic_print_words_for_issue_edit($issue_id) {
}

function dic_print_user_issue($issue_id) {
  global $lang;
  
  $user_id=user_getid();
  
  if (dic_is_issue_owner($issue_id)) {
    
    // select the user's issues
    $sql="SELECT issue_name, issue_desc, start_date, image_src, rudeness, is_open FROM issues WHERE issue_id = '$issue_id'";
    $result=db_query($sql);
    $nb= db_numrows($result);
    
    if ($nb > 0) { // This user owns some issues, print them out.
      
      $issue_name = db_result($result,'0','issue_name');
      $issue_desc = db_result($result,'0','issue_desc');
      $start_date = db_result($result,'0','start_date');
      $image_src = db_result($result,'0','image_src');
      $rudeness_rating = db_result($result,'0','rudeness');
      $is_open = db_result($result,'0','is_open');
      
      if ($rudeness_rating == 1) {
	$rude_checked='CHECKED';
      }
      
      $printout.= '<FORM ACTION="'.$PHP_SELF.'" METHOD="POST">'."\n";
      $printout.= '<INPUT TYPE="TEXT" NAME="issue_name" VALUE="'.$issue_name.'" SIZE="20" MAXLENGTH="20"><br>'."\n";
      $printout.= '<b>'.$lang[start_date].'</b>: '.$start_date.'<br>'."\n";
      $printout.= '<B>'.$lang[issue_description].'</B><br>'."\n";
      $printout.= '<TEXTAREA NAME="issue_desc" rows="5" cols="30">'.$issue_desc.'</TEXTAREA><br>'."\n";
      $printout.= '<b>'.$lang[image_src].'</b><br>'."\n";
      $printout.= 'htp://<INPUT TYPE="TEXT" NAME="image_src" VALUE="'.$image_src.'" SIZE="50" MAXLENGTH="100"><br>'."\n";
      $printout.= '<INPUT TYPE="hidden" NAME="user_id" value="'.$user_id.'">'."\n";
      $printout.= '<INPUT TYPE="hidden" NAME="issue_id" value="'.$issue_id.'">'."\n";
      $printout.= $lang[this_is_rude].'<INPUT TYPE="checkbox" NAME="rudeness_rating" value="1" '.$rude_checked.'><br>';
      $printout.= dic_print_add_to_issue_options($is_open);
      $printout.= '<br><INPUT TYPE="SUBMIT" NAME="submit" VALUE="'.$lang[alter_issue].'">'."\n";
      if (!user_is_guest()) {
	$printout.= '<br><INPUT TYPE="SUBMIT" NAME="delete" VALUE="'.$lang[delete_issue].'">'."\n";
      }
      $printout.= '</FORM>'."\n";
    
      $printout.=dic_print();  
      return $printout;
      // print out the admin page for this issue (it will go for this issue automatically because
      // issue_id is set
    
      
    } else {
      // There are no issues for this user
      $feedback.= "$lang[no_issues_for_this_user]";
      return false;
    }
    
  } else {
    // This user doesn't own this issue
    $feedback.=$lang['you_are_not_issue_owner'];
    return false;
    
  }
  
}

function dic_add_or_alter_issue($issue_name,$issue_desc,$image_src,$issue_id, $is_open, $rudeness_rating) {
  
  global $feedback, $site_url, $dicshunary_root_path, $lang;
  
  if (empty($rudeness_rating)) {
    $rudeness_rating = 0;
  }
  
  //strip html tags from name input
  $issue_name = strip_tags($issue_name);
  $issue_name = str_replace('<!--', '', $issue_name);
  
  //strip html tags from description input
  $issue_desc = strip_tags($issue_desc);
  $issue_desc = str_replace('<!--', '', $issue_desc);
  
  //strip html tags from image source input
  $image_src = strip_tags($image_src);
  $image_src = str_replace('<!--', '', $image_src);
  
  
  // get user id
  $user_id=user_getid();
  
  // input error checking
  
  //all absolutely necessary vars present and correct?
  if (empty($user_id)) {
    $feedback.= $lang[you_need_to_be_logged_in];
    return false;
  } elseif (empty($issue_name)) {
    $feedback.= $lang[error_no_issue_name];
    return false;
  } elseif (empty($issue_desc)) {
    $feedback.= $lang[error_no_issue_desc];
    return false;
  } else {
    
    //
    // Insert / update issue
    //
    
    
    // only add a new issue if there is no issue_id (in which case we update instead)
    if (empty($issue_id))	{
      
      //does an issue with this name exist?
      $sql="SELECT * FROM issues WHERE issue_name='$issue_name'";
      $result=db_query($sql);
      if ($result && db_numrows($result) > 0) {
	// issue name already exists, throw an error
	$feedback.= $lang[error_issue_name_exists];
	return false;
      }
      // if we don't have "$is_open" we set it to "no".
      if (!isset($is_open)) {
	$is_open="0";
      }
      
      //insert the new issue into the dicshunary.
      $sql="INSERT INTO issues (issue_name,issue_desc,image_src, start_date, is_open, rudeness) ".
	 "VALUES ('$issue_name','$issue_desc','$image_src', now(), '$is_open', '$rudeness_rating')";
      $result=db_query($sql);
      if (!$result) {
	$feedback .= ' ERROR - '.db_error();
	return false;
      } 
      // clear the result so we can get useful error if next db op fails.
      unset($result);
      
      // get the issue_id of the issue we just inserted
      $issue_id=dic_get_issue_id($issue_name);
      
      // Insert issue authorship relations
      
      // insert relationship between issue and author
      $sql="INSERT INTO relations (issue_id, user_id)".
	 "VALUES ('$issue_id','$user_id')";
      $result=db_query($sql);
      if (!$result) {
	$feedback .=' ERROR -'.db_error();
	return false;
      }
      // clear result again
      unset($result);
      
    } else {
      // Update an existing issue
      $sql="UPDATE issues SET issue_name = '$issue_name', issue_desc = '$issue_desc', image_src = '$image_src', is_open='$is_open', rudeness='$rudeness_rating' WHERE issue_id = '$issue_id'";
      $result=db_query($sql);
      if (!$result) {
	$feedback .= ' ERROR - '.db_error();
	return false;
      } 
      $updated=1;
    }
    
    // now give appropriate feedback
    if ($updated==1) {
      $feedback .= "$lang[the_issue] \"$issue_name\" $lang[has_been_updated] ";
    } else {
      $feedback .= "$lang[the_issue] \"$issue_name\" $lang[has_been_added] ";
    }
    // email admin to say something new has been added and should be rated
    dic_send_add_text_email("\n\n issue-name: ".$issue_name."\n\n issue_description:\n'".$issue_desc, $issue_id,$user_id, 'issue', $rudeness);
    
    return true;
  }
}

function dic_issue_delete($issue_id) {
  
  global $feedback, $site_url, $dicshunary_root_path, $lang;
  include($dicshunary_root_path.'common.inc');
  
  if (dic_is_issue_owner($issue_id)) {
    // fucking mysql 3.ARSE won't do multiple deletes so we have to be really lame about this and do 2 queries. dah!
    // first we delete from the issues table
    $sql="DELETE FROM issues where issue_id = '$issue_id'";
    $result=db_query($sql);
    if (!$result) {
      $feedback .= ' ERROR - '.db_error();
      return false;
    }
    // now we delete from the relations table
    $sql="DELETE FROM relations where issue_id = '$issue_id'";
    $result=db_query($sql);
    if (!$result) {
      $feedback .= ' ERROR - '.db_error();
      return false;
    }
    
    $feedback.=$lang[your_issue_has_been_deleted];
    return true;
    
  } else {
    $feedback.=$lang[you_are_not_issue_owner];
    return false;
  }
}

function dic_print_issue_selector($type, $limit_number) {
  // this hack is pretty untidy... cleaning it up should be on the wish list
  global $site_url, $dicshunary_root_path, $lang, $rudeness, $mode, $installation;
  include($dicshunary_root_path.'common.inc');
  
  if ($limit_number > 0) {
    $limit = "LIMIT $limit_number";
  } else {
    unset($limit);
  }
  
  if ($rudeness != 'rude') {
    $rudeness_limit = 'WHERE rudeness < 1';
  }
  
  $sql="SELECT issue_name, issue_id FROM issues $rudeness_limit ORDER BY issue_id desc $limit ";
  
  $result=db_query($sql);
  $nb= db_numrows($result);
  $row=0;
  
  if ($nb > 0) { // There are some personal dictionaries
    
    if ($type == 'select') {
      $printout="<SELECT NAME=\"issue\">";
    }
    
    while ($row < $nb) {  
      
      $issue_id = db_result($result,$row,"issue_id");
      $issue_name = db_result($result,$row,"issue_name");
      
      if(user_isadmin() && $mode=='admin') {
	$admin_links=" - [<A HREF=\"delete_entries.$phpEx?issue_id=$issue_id\">delete</A>]";
      }
      
      if ($type == 'select') {
	// hack! - but not such a bad one
	if(strtoupper($issue_name) == strtoupper($installation)) {
	  print "$issue_name, $installation";
	  $printout.="<OPTION value=\"$issue_id\" SELECTED > $issue_name </OPTION>";
	} else {
	  $printout.="<OPTION value=\"$issue_id\" $selected > $issue_name </OPTION>";
	}
      } else {
	$url_issue_name=urlencode($issue_name);
	$printout.="- <a href=\"view_dict.$phpEx?issue_id=$issue_id&issue_name=$url_issue_name\">$issue_name</a>$admin_links<br>";
      }
      
      $row++; 
    }
    
    if ($type == 'select') {
      $printout.="</SELECT>";
    }
    
    return $printout;
    
  } else {
    // There are no dicshunaries, print an apology
    if ($rudeness!= 1 && $nb > 0) {
      $printout.='<span class="feedback">'.$lang[sorry_there_are_no_polite_issues].'<br></span>';
    } else {
      $printout.='<span class="feedback">'.$lang[sorry_there_are_no_issues].'<br></span>';
    }
    return $printout;
    
  }
  
}

function dic_user_has_words() {
  global $dicshunary_root_path;
  include($dicshunary_root_path.'common.inc');
  
  $user_id=user_getid();
  $sql="SELECT * FROM relations WHERE user_id = '$user_id' AND word_id > 0";
  $result=db_query($sql);
  $nb=db_numrows($result);
  
  if ($nb > 0 ) {
    return true;
  } else {
    return false;
  }
  
  
}

function dic_print_admin_button() {
  global $lang, $mode, $QUERY_STRING;
  if ($QUERY_STRING) {
    $query_string='?'.$QUERY_STRING.'&mode=';
  } else {
    $query_string='?mode=';
  }
  if (user_isadmin()) {
    if ($mode =='admin') {
      return "<a href=\"$PHP_SELF".$query_string."view\">$lang[view_mode]</a>";
    } else {
      return "<a href=\"$PHP_SELF".$query_string."admin\">$lang[admin_mode]</a>";
    }
  }
}

function dic_user_has_rated_word($user_id, $word_id) {
  global $NOT_RATE_RESULT;
  //see if we have already fetched this word from the db, if not, fetch it
  if (!$NOT_RATE_RESULT) {
    $NOT_RATE_RESULT=db_query("SELECT user_id FROM ratings where word_id  = '$word_id' AND user_id = '$user_id'");
  }
  if ($NOT_RATE_RESULT && db_numrows($NOT_RATE_RESULT) > 0) {
    return true;
  } else {
    return false;
	}
}


function dic_rate_word($word_id,$opinion) {
  global $lang, $feedback;
  $user_id = user_getid();
  if (dic_user_has_rated_word($user_id, $word_id)) {
    $feedback.=$lang[you_already_rated_that_one];
    return false;
  } else {
    if ($opinion == 'good') {
      $plusorminus = '+';
    } elseif ($opinion == 'bad') {
      $plusorminus = '-';
    } else {
      return false;
    }
    $sql="UPDATE words SET rating = (rating".$plusorminus."1) WHERE word_id = '$word_id'";
    $result=db_query($sql);
    if (!$result) {
      $feedback .= ' ERROR - '.db_error();
      return false;
    } else {
      $sql="INSERT INTO ratings (word_id,user_id) ".
	 "VALUES ('$word_id','$user_id')";
      $result=db_query($sql);
      if (!$result) {
	$feedback .= ' ERROR - '.db_error();
	return false;
      } else {
	$feedback.=$lang[your_vote_was_recorded];
	return true;
      }
    }
  }
}

function dic_is_word_owner($word_id) {
  global $site_url, $dicshunary_root_path, $lang;
  include($dicshunary_root_path.'common.inc');
  
  $user_id=user_getid();
  
  $sql="SELECT user_id FROM relations WHERE word_id = '$word_id' AND user_id = '$user_id'";
  $result=db_query($sql);
  $nb=db_numrows($result);
  
  if ($nb > 0 ) {
    return true;
  } else {
    return false;
  }
  
}

function dic_get_word_rating($word_id){
  $sql="SELECT rating FROM words WHERE word_id = '$word_id'";
  $result=db_query($sql);
  if ($result && db_numrows($result) > 0) {
    $word_rating=db_result($result,'0',"rating");
    return $word_rating;
  } else {
    return false;
  }
}

function dic_was_word_of_day($word_id) {
  $sql="SELECT dayname(date_chosen) as day, dayofmonth(date_chosen) as date, monthname(date_chosen) as month, year(date_chosen) as year FROM word_of_day WHERE word_id = '$word_id'";
  $result=db_query($sql);
  if ($result && db_numrows($result) > 0) {
    $day=db_result($result,'0','day');
    $date=db_result($result,'0','date');
    $month=db_result($result,'0','month');
    $year=db_result($result,'0','year');
    $date_chosen="$day, $date $month, $year";
    return $date_chosen;
  } else {
    return false;
  }
  
}

function dic_print_vote_form($word_text) {
  global $lang;
  $word_id = dic_get_word_id($word_text);
  $user_id = user_getid();
  
  if (user_isloggedin() && !dic_user_has_rated_word($user_id, $word_id) && !dic_was_word_of_day($word_id)) {
    $printout.= "- [ <A HREF=\"$PHP_SELF?rate_word=1&word_id=$word_id&opinion=good\">$lang[nominate]</a> ] \"$word_text\" $lang[for_word_of_the_day].<p>";
  }
  return $printout;
}

function dic_how_many_votes_needed($word_id) {
  $sql="SELECT rating from words where word_id = '$word_id'";
  $result=db_query($sql);
  if ($result && db_numrows($result) > 0) {
    $rating=db_result($result,'0',"rating");
    $sql="SELECT rating from words order by rating desc limit 1";
    $result=db_query($sql);
    if ($result && db_numrows($result) > 0) {
      $top_rating=db_result($result,'0', "rating");
      // so the number of votes needed is...
      $votes_needed = ($top_rating - $rating);
      return $votes_needed;
    } else {
      return false;
    }
  } else {
    return false;
  }
}

function dic_print_word_stats($word_text) {
  global $lang;
  $word_id = dic_get_word_id($word_text);
  
  // is this your word?
  if (dic_is_word_owner($word_id)) {
    $printout.='- <br><b>"'.$word_text.'" '.$lang[is_one_of_yours].'</b>';
  }
  
  // has this word been word of the day?
  if ($date_was_wod=dic_was_word_of_day($word_id)) {
    $printout.='<br>- "'.$word_text.'" '.$lang[was_wod_on].' '.$date_was_wod.' ';
  } else {
    // it wasn't word of the day, so print out how many votes are needed for it to become wod.
    if ($how_many_votes_needed=dic_how_many_votes_needed($word_id)) {
      $printout.='<br>- '.$how_many_votes_needed.' '.$lang[votes_for].' "'.$word_text.'" '.$lang[are_needed_for_it_to_be_wod].'';
    }
  }
  
	
  return $printout;
  
}


function dic_print_add_word_to_issue_form($word_text) {
  global $lang;
  if ($issue_select=dic_print_add_to_issue_select(0)) {
    $printout.='<FORM ACTION="'. $PHP_SELF .'" METHOD="POST">';
    $printout.='<h2>'.$lang[Add].' "'.$word_text.'" '.$lang[to_an_issue].'</h2>'.$issue_select;
    $word_id=dic_get_word_id($word_text);
    $printout.='<INPUT TYPE="HIDDEN" NAME="word_id" VALUE="'.$word_id.'">';
    $printout.=' <INPUT TYPE="SUBMIT" NAME="add_to_issue" VALUE="'.$lang[add_word].'">';
    $printout.='</FORM>';
    return  $printout;
  }
}

function dic_delete_word_from_issue($word_id, $issue_id) {
  global $lang, $feedback, $email_remove;
  if (dic_is_issue_owner($issue_id)) {
    // delete relaiton between issue and word
    $sql="DELETE from relations WHERE word_id='$word_id' AND issue_id='$issue_id'";
    $result=db_query($sql);
    if (!$result) {
      $feedback .=' ERROR -'.db_error();
      return false;
    } else {
      $feedback.='<br>'.$lang[the_word_was_deleted_from_your_issue];
      return true;
    }
  } else {
    // if this is the issue owner responding to the email without being logged in, say so.
    if ($email_remove) {
      $feedback.=$lang[you_must_be_logged_in_to_remove].'<br>';
    } else { 
      $feedback.=$lang[you_are_not_issue_owner];
    }
    return false;
  }
}

function rate_text($rating) {
  global $word_id, $issue_id, $def_id, $lang, $feedback, $HTTP_REFERER;
  // check this is authorized
  if (user_isadmin()) {
    
    // first, set the rating to 1 or 0
    if ($rating == 'polite') {
      $rudeness = 0;
    } elseif ($rating == 'rude') {
      $rudeness = 1;
    } else {
      $feedback.=$lang[there_was_no_rating];
      return false;
    }
    
    // then, find out what kind of text input we're rating
    if (!empty($word_id)) {
      $tablename = 'words';
      $colname = 'word_id';
      $col_id = $word_id;
    } elseif (!empty($issue_id)) {
      $tablename = 'issues';
      $colname = 'issue_id';
      $col_id = $issue_id;
    } elseif (!empty($def_id)) {
      $tablename = 'definitions';
      $colname = 'def_id';
      $col_id = $def_id;
    } else {
      $feedback.=$lang[there_was_no_id];
      return false;
    }
    
    // now do the rudeness update
    $sql="UPDATE $tablename SET rudeness = $rudeness WHERE $colname = $col_id";
    $result=db_query($sql);
    if (!$result) {
      $feedback .=' ERROR -'.db_error();
      return false;
    } else {
      if ($HTTP_REFERER) {
	header("Location:$HTTP_REFERER");
      } else {
	$feedback .=$lang[that_was_rated_as].' '.$rating;
	return true;
      }
    }
    
    
  } else {
    $feedback.=$lang[you_are_not_authorized_to_rate_entries];
    return false;
  }
  
}

function dic_print_users() {
  
  if (user_isadmin()) {
    
    global $feedback, $lang;
    include($dicshunary_root_path.'common.inc');
    
    
    $sql="SELECT user_id, user_name, real_name, email, is_admin FROM user";
    $result=db_query($sql);
    $nb= db_numrows($result);
    $row=0;
    
    $printout.="<FORM action=\"$PHP_SELF\" method=\"POST\"><ol>";
    
    if ($nb > 0) { // There are some users print them out.
      
      while ($row < $nb) { 
	$user_id = db_result($result,$row,'user_id');
	$user_name = db_result($result,$row,'user_name');
	$real_name = db_result($result,$row,'real_name');
	$email = db_result($result,$row,'email');
	$is_admin = db_result($result,$row,'is_admin');
	
	$printout.="<li><b>$user_name</b> [$real_name] - $email -";
	
	if ($is_admin == 1) {
	  $printout.=' [<span class="feedback"> ADMIN </span>]';
	}
	$printout.='<INPUT TYPE="radio" NAME="user_id" value="'.$user_id.'"></li>';
	$row++;
      }
      
    } else { 
      return false;
    }
    $printout.='</ol><INPUT TYPE="submit" name="make_admin" value="'.$lang[make_admin].'">';
    if (user_isfirstadmin()) {
      $printout.='</ol><INPUT TYPE="submit" name="unmake_admin" value="'.$lang[unmake_admin].'">';
    }
    $printout.='</FORM>';
    return $printout;
    
  } else {
    header("Location:$HTTP_REFERER");
  }
  
}

function dic_make_user_admin($user_id) {
  global $feedback, $lang;
  if (user_isadmin() && !empty($user_id)) {
    // Update an existing issue
    $sql="UPDATE user SET is_admin = '1' WHERE user_id = '$user_id'";
    $result=db_query($sql);
    if (!$result) {
      $feedback .= ' ERROR - '.db_error();
      return false;
    } 
    $feedback.=$lang[user_upgraded_to_admin];
    return true;
  } else {
    $feedback.=$lang[you_are_not_authorized];
  }
}

function dic_unmake_user_admin($user_id) {
  global $feedback, $lang;
  // first, make sure the first admin trying (duh) to downgrade themselves:
  if ($user_id == 1) {
    $feedback.=$lang[you_cant_downgrade_the_first_admin];
    return false;
  } else {
    if (user_isfirstadmin() && !empty($user_id)) {
      // Update an existing issue
      $sql="UPDATE user SET is_admin = '0' WHERE user_id = '$user_id'";
      $result=db_query($sql);
      if (!$result) {
	$feedback .= ' ERROR - '.db_error();
	return false;
      } 
      $feedback.=$lang[user_downgraded];
      return true;
    } else {
      $feedback.=$lang[you_are_not_authorized];
    }
  }
}

function dic_show_wod($mode) {
  global $lang, $feedback, $rudeness, $phpEx;
  // $mode can be 'full' (show the word_of_the_day on a web page with definitions and everything) 
  // or 'short' (just a line for inclusion in other pages).
  // or 'mail' (formatted for an email)
  // check to see if there is a word of the day.
  $sql="SELECT word_of_day.word_id, word_text, words.rudeness as wod_rudeness, words.rating, dayname(date_added) as day, dayofmonth(date_added) as date, monthname(date_added) as month, year(date_added) as year FROM words,".
     "word_of_day WHERE date_chosen = curdate() AND words.word_id = word_of_day.word_id";
  $result=db_query($sql);
  if (db_numrows($result) == 0) {
    // if we get nothing back, there is no word of the day for today, so we choose one
    if (!dic_choose_word_of_day($mode)) {
      return $lang[sorry_no_wod_today];
    }
  } else {
    // we got something back, display it.
    $word_text=db_result($result,'0','word_text');
    $word_id=db_result($result,'0','word_id');
    $wod_rudeness=db_result($result,'0','wod_rudeness');
    $rating=db_result($result,'0','rating');
    $day=db_result($result,'0','day');
    $date=db_result($result,'0','date');
    $month=db_result($result,'0','month');
    $year=db_result($result,'0','year');
    
    // if the user doesn't like rudeness, and the word is rude, tell them.
    if($rudeness!= 'rude' && $wod_rudeness == 1) {
      return '<span class="feedback">'.$lang[sorry_todays_wod_is_too_rude_for_you].'</span>';
      return false;
    } else { 
      // yay! they like rudeness now add the word to $printout
      if ($mode == 'short') {
	// mode is short, just write a little sentence
	$printout.=$lang[word_of_the_day_today_is].' <a href="word_of_the_day.'.$phpEx.'">'.$word_text.'</a>';
      } elseif ($mode=='mail') {
	// mode is mail, format this for a mailing list (no html, \n for linebreaks etc...)
	$printout.=$lang[word_of_the_day_today_is].' '.$word_text."\n";
	$printout.="-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- \n";
	// add definitions
	$printout.=$lang[definitions].": \n";
	$printout.=dic_get_definitions($word_text, 'mail');
	return $printout;
      } else { 
	// mode is long - show definitions etc...
	$printout.='<h1>'.$lang[word_of_the_day_today_is].' <span class="feedback">'.$word_text.'</span></h1>';
	$printout.='<p><h2>'.$lang[definitions].': </h2><ul>';
	
	//get word definitions
	$printout.=dic_get_definitions($word_text, 'html');
	
	// add rating and date_added info
	$printout.='</ul><p><b>'.$lang[rating].': <i>'.$rating.'</i></b>';
	$printout.='<p><b>'.$lang[date_added].' <i>'."$day, $date $month, $year".'</i></b>';
      }
      
      return $printout;
    }
    
  }
}

function dic_get_definitions($word_text, $mode) {
  global $lang, $rudeness;
  
  // mode is 'html' or 'mail' - set it here
  if ($mode=='html') {
    $newline='<li>';
    $endline='</li>';
  } elseif ($mode == 'mail') {
    $newline="\n - ";
    $endline="\n ";
  }
  
  // get the word_id 
  $word_id = dic_get_word_id($word_text);
  //select definitions and print it all out.
  $sql="SELECT def_text, rudeness as def_rudeness FROM definitions WHERE word_id = $word_id";
  $result=db_query($sql);
  if ($result) {
    $nb=db_numrows($result);
    $row=0;
    
    while ($row < $nb) { 
      $def_text = db_result($result,$row,'def_text');
      $def_rudeness = db_result($result,$row,'def_rudeness');
      if ($rudeness !='rude' && $def_rudeness == 1) {
	$printout.=$newline.$lang[this_definition_is_too_rude_for_you].$endline;
      } else {
	$printout.=$newline.$def_text.$endline;
      }
      $row++;
    }
    return $printout;
  } else {
    return false;
  }
  
  
}



function dic_choose_word_of_day($mode) {
  // for an explanation of $mode see dic_show_wod() above
  global $lang, $feedback;
  $sql="SELECT words.word_id, words.rudeness, words.word_text, words.rating FROM words LEFT JOIN word_of_day ON words.word_id=word_of_day.word_id WHERE word_of_day.word_id IS NULL ORDER BY rating DESC, rand() LIMIT 1";
  $result=db_query($sql);
  $word_id = db_result($result,'0','word_id');
  $rudeness = db_result($result,'0','rudeness');
  $word_text = db_result($result,'0', 'word_text');
  
  // now insert it into word_of_day table
  if (!empty($word_id)) {
    $sql="INSERT INTO word_of_day (word_id, date_chosen, rudeness) VALUES ('$word_id', curdate(), '$rudeness')";
    $result=db_query($sql);
    if (!$result) {
      $feedback .=' ERROR -'.db_error();
      return false;
    } else {
      dic_show_wod($mode);
      dic_mail_lists($word_id, $word_text, $rudeness);
      return true;
    }
  } 
}


function dic_show_wod_archive() {
  global $lang, $feedback, $phpEx;
  $sql="SELECT dayofmonth(date_chosen) as date, monthname(date_chosen) as month, year(date_chosen) as year, word_text FROM words, word_of_day WHERE words.word_id = word_of_day.word_id AND date_chosen != curdate()";	
  $result=db_query($sql);
  if ($result) {
    $nb=db_numrows($result);
    $row=0;
    while ($nb > $row) {
      $word_text=db_result($result,$row,'word_text');
      $date=db_result($result,$row,'date');
      $month=db_result($result,$row,'month');
      $year=db_result($result,$row,'year');
      
      $printout.="$lang[On] $date $month, $year <a href=\"word_options.$phpEx?word_text=$word_text\">$word_text</a> $lang[was_wod] <br>";
      $row++;
    }
    return $printout;
  } else {
    return false;
  }
}



function dic_mail_lists($word_id, $word_text, $rudeness) {
  global $lang, $rude_list_email, $polite_list_email, $admin_email, $site_name, $site_url, $phpEx;
  // mail the mailing list
  $subject=$lang[from].' '.$site_name.': '.$word_text;
  $message=dic_show_wod('mail');
  
  // add extra info and options to the mail
  
  $message.="\n\n-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- \n";
  $message.=$lang[to_add_your_own_definition_of].' '.$word_text.' '.$lang[visit];
  $message.=" \n".$site_url.'word_options.'.$phpEx.'?word_text='.$word_text;
  $message.="\n$lang[or_add_your_own_words_at] $site_url";
  
  if ($rudeness == '0') {
    //mail both mailing lists
    mail($polite_list_email,$subject,$message,'FROM: '.$admin_email); 
    mail($rude_list_email,$subject,$message,'FROM: '.$admin_email); 
  } else {
    // only mail the rude mailing list
    mail($rude_list_email,$subject,$message,'FROM: '.$admin_email); 
  }
  
}




function dic_download_dic() {
  global $site_name, $lang;
  
  $today = getdate(); 
  $month = $today['month']; 
  $mday = $today['mday']; 
  $year = $today['year']; 
  $now_time = "$mday $month, $year";
  
  // name the file
  $filename ="doc/dicshunary.php";
  
  
  // fill the text string
  $string.='<?php '."\n".'header("Content-type: text/html");';
  $string.="\n".'header("Content-Disposition: attachment; filename="'.$PHP_SELF.'); ?>'."\n\n";
  
  $string .= '<html><title>'.$lang[download_of].' '.$site_name.' '.$now_time.'</title><body>';
  $string .= dic_print();
  $string .='</body></html>';
  
  // delete existing file if it exists
  if (file_exists($filename)) {
    unlink($filename);
  }
  
  // open new file for writing
  $handle= fopen($filename,'a');
  
  // write string to file
  fputs($handle, $string);
  
  // close file
  fclose($handle);
  
}

function dic_show_most_recent_word() {
  // grab the most recent word from the dic, and return it with a link to it's options page.
  global $phpEx, $site_url;
  $sql='SELECT max(word_id)as max from words';
  $result=db_query($sql);
  $max = db_result($result, '0', 'max');
  $word_text = dic_get_word_text($max);
  if (!empty($word_text)) {
    return '<a href="'.$site_url.'word_options.'.$phpEx.'?word_text='.$word_text.'">'.$word_text.'</a>';
  } else {
    return false;
  }
}

function user_is_guest() {
  // this is a horrible hack, but can be upgraded nicely easily in the next version
  $user_id = user_getid();
  if ($user_id == 3) {
    // user is a guest as we preloaded the table with guest with user_id = 2
    return true;
  } else {
    // user is not a guest 
    return false;
  }
}

function dic_print_add_to_issue_options($is_open) {
  global $lang;
  if (!user_is_guest()) {
    // if we are editing, $is_open will be set, so we can select the relevant one.
    if (isset($is_open) && $is_open == 0) {
      $selected_0 = 'SELECTED';
    } elseif ($is_open == 1) {
      $selected_1 = 'SELECTED';
    } elseif ($is_open == 2) {
      $selected_2 = 'SELECTED';
    }
    $printout.= '<br><select name = "is_open">';
    $printout.= '<option value="1"'.$selected_1.'>'.$lang[open_add_to_issue].'</option>'."\n";
    $printout.= '<option value="0"'.$selected_0.'>'.$lang[closed_add_to_issue].'</option>'."\n";	
    $printout.= '<option value="2"'.$selected_2.'>'.$lang[require_email_conf_to_add].'</option>'."\n";
    $printout.= '</select> '.$lang[to_add_words_to_this_issue].'<br>'."\n";
  } else {
    $printout.= '<input type = "hidden" name = "is_open" value="1">'."\n";
    $printout.= $lang[guest_issue_is_open].'<br>'."\n";
  }
  return $printout;
}

function dic_print_alpha_list() {
  global $PHP_SELF;
  $sql='SELECT DISTINCT LEFT(word_text,1) as first_letter FROM words ORDER BY first_letter';
  $result=db_query($sql);
  $nb=db_numrows($result);
  $row=0;
  if ($nb > $row) {
    while ($nb > $row) {
      $first_letter=db_result($result,$row,'first_letter');
      $printout.=" | <a href=\"$PHP_SELF?letter=$first_letter\">".strtoupper($first_letter)."</a>";
      $row++;
    } 
    
    $printout.=' |';

    return $printout;

  }
}

?>
