<?php

/***************************************************************************  
 *                            user_functions.php
 *                            -------------------                         
 *   begin                : Saturday 20th April 2002 
 *   copyright            : (C) 2002 Saul Albert      
 *   email                : code@dicshunary.com                          
 *                                                          
 *   $Id: /user_functions.php/1.1.1.1/Sun Jul  7 12:17:09 2002//
 *                                                            
 * 
 ***************************************************************************/ 

$hidden_hash_var='dicshunary_password';


$LOGGED_IN=false;
//clear it out in case someone sets it in the URL or something
unset($LOGGED_IN);


function user_isloggedin() {
  global $user_name,$id_hash,$hidden_hash_var,$LOGGED_IN;
  //have we already run the hash checks? 
  //If so, return the pre-set var
  if (isset($LOGGED_IN)) {
    return $LOGGED_IN;
  }
  if ($user_name && $id_hash) {
    $hash=md5($user_name.$hidden_hash_var);
    if ($hash == $id_hash) {
      $LOGGED_IN=true;
      return true;
    } else {
      $LOGGED_IN=false;
      return false;
    }
  } else {
    $LOGGED_IN=false;
    return false;
  }
}

function user_login($user_name,$password) {
  global $dicshunary_root_path, $lang;
  include($dicshunary_root_path.'common.inc');
  global $feedback;
  if (!$user_name || !$password) {
    $feedback .=  "$lang[error_no_uname_pass]";
    return false;
  } else {
    $user_name=strtolower($user_name);
    $password=strtolower($password);
    $sql="SELECT * FROM user WHERE user_name='$user_name' AND password='". md5($password) ."'";
    $result=db_query($sql);
    if (!$result || db_numrows($result) < 1){
      $feedback .="$lang[error_no_pass_or_wrong]";
      return false;
    } else {
      if (db_result($result,0,'is_confirmed') == '1') {
	user_set_tokens($user_name);
	$feedback .=  "$lang[login_success]";
	return true;
      } else {
	$feedback .=  "$lang[error_not_confirmed]";
	return false;
      }
    }
  }
}

function user_logout() {
  setcookie('user_name','',(time()+2592000),'/','',0);
  setcookie('id_hash','',(time()+2592000),'/','',0);
}

function user_set_tokens($user_name_in) {
  global $hidden_hash_var,$user_name,$id_hash;
  if (!$user_name_in) {
    $feedback .=  ' ERROR - User name missing when setting tokens ';
    return false;
  }
  $user_name=strtolower($user_name_in);
  $id_hash= md5($user_name.$hidden_hash_var);
  
  setcookie('user_name',$user_name,(time()+2592000),'/','',0);
  setcookie('id_hash',$id_hash,(time()+2592000),'/','',0);
}

function user_confirm($hash,$email) {
  /*
		Call this function on the user confirmation page,
		which they arrive at when the click the link in the
		account confirmation email
  */
  
  global $feedback,$hidden_hash_var, $lang, $dicshunary_root_path;
  include($dicshunary_root_path.'common.inc');
  //verify that they didn't tamper with the email address
  $new_hash=md5($email.$hidden_hash_var);
  if ($new_hash && ($new_hash==$hash)) {
    //find this record in the db
    $sql="SELECT * FROM user WHERE confirm_hash='$hash'";
    $result=db_query($sql);
    if (!$result || db_numrows($result) < 1) {
      $feedback .= ' ERROR - Hash Not Found ';
      return false;
    } else {
      //confirm the email and set account to active
      $feedback .= "$lang[login_success]";
      user_set_tokens(db_result($result,0,'user_name'));
      $sql="UPDATE user SET email='$email',is_confirmed='1' WHERE confirm_hash='$hash'";
      $result=db_query($sql);
      return true;
    }
  } else {
    $feedback .= ' HASH INVALID - UPDATE FAILED ';
    return false;
  }
}

function user_change_password ($new_password1,$new_password2,$change_user_name,$old_password) {
  global $feedback, $lang, $dicshunary_root_path;
  include($dicshunary_root_path.'common.inc');
  //new passwords present and match?
  if ($new_password1 && ($new_password1==$new_password2)) {
    //is this password long enough?
    if (account_pwvalid($new_password1)) {
      //all vars are present?
      if ($change_user_name && $old_password) {
	//lower case everything
	$change_user_name=strtolower($change_user_name);
	$old_password=strtolower($old_password);
	$new_password1=strtolower($new_password1);
	$sql="SELECT * FROM user WHERE user_name='$change_user_name' AND password='". md5($old_password) ."'";
	$result=db_query($sql);
	if (!$result || db_numrows($result) < 1) {
	  $feedback .= "$lang[bad_user_or_pass]".db_error();
	  return false;
	} else {
	  $sql="UPDATE user SET password='". md5($new_password1). "' ".
	     "WHERE user_name='$change_user_name' AND password='". md5($old_password). "'";
	  $result=db_query($sql);
	  if (!$result || db_affected_rows($result) < 1) {
	    $feedback .="$lang[nothing_changed]".db_error();
	    return false;
	  } else {
	    $feedback .= "$lang[password_changed]";
	    return true;
	  }
	}
      } else {
	$feedback .= "$lang[need_uname_and_old_pass]";
	return false;
      }
    } else {
      $feedback .= "$lang[new_pass_no_good]";
      return false;
    }
  } else {
    return false;
    $feedback .="$lang[new_passes_must_match]";
  }
}

function user_lost_password ($email,$user_name) {
  global $dicshunary_root_path, $lang;
  include($dicshunary_root_path.'common.inc');
  global $feedback,$hidden_hash_var;
  if ($email && $user_name) {
    $user_name=strtolower($user_name);
    $sql="SELECT * FROM user WHERE user_name='$user_name' AND email='$email'";
    $result=db_query($sql);
    if (!$result || db_numrows($result) < 1) {
      //no matching user found
      $feedback .= "$lang[error_bad_uname_or_pass2]";
      return false;
    } else {
      //create a secure, new password
      $new_pass=strtolower(substr(md5(time().$user_name.$hidden_hash_var),1,14));
      
      //update the database to include the new password
      $sql="UPDATE user SET password='". md5($new_pass) ."' WHERE user_name='$user_name'";
      $result=db_query($sql);
      
      //send a simple email with the new password
      mail ($email,$lang[password_changed], $lang[password_changed]." to: \n\n".$new_pass."\n\n $lang[now_you_can_log_in]",'From: conny@dicshunary.com');
      $feedback .= "$lang[new_pass_emailed]";
      return true;
    }
  } else {
    $feedback .= "$lang[error_uname_email_req2]";
    return false;
  }
}

function user_change_email ($password1,$new_email,$user_name) {
  global $feedback,$hidden_hash_var, $lang, $dicshunary_root_path;
  include($dicshunary_root_path.'common.inc');
  if (validate_email($new_email)) {
    $hash=md5($new_email.$hidden_hash_var);
    //change the confirm hash in the db but not the email - 
    //send out a new confirm email with a new hash
    $user_name=strtolower($user_name);
    $password1=strtolower($password1);
    $sql="UPDATE user SET confirm_hash='$hash' WHERE user_name='$user_name' AND password='". md5($password1) ."'";
    $result=db_query($sql);
    if (!$result || db_affected_rows($result) < 1) {
      $feedback .= "$lang[error_bad_uname_or_pass2]";
      return false;
    } else {
      $feedback .= "$lang[confirmation_sent]";
      user_send_confirm_email($new_email,$hash);
      return true;
    }
  } else {
    $feedback .= "$lang[new_email_invalid]";
    return false;
  }
}

function user_send_confirm_email($email,$hash) {
  global $dicshunary_root_path, $lang, $site_url;
  /*
		Used in the initial registration function
		as well as the change email address function
  */
  
  $message = "$lang[thanks_for_reg]".
     "\n\n $site_url".
     "$registration_dir".
     "confirm.php?hash=$hash&email=". urlencode($email).
     "\n\n $lang[reason_to_register]".
     "\n\n $lang[disclaimer]";
  mail ($email,'Registration Confirmation',$message,'From: conny@dicshunary.com');
}

function user_register($user_name,$password1,$password2,$email,$real_name) {
  global $dicshunary_root_path, $lang;
  include($dicshunary_root_path.'common.inc');
  global $feedback,$hidden_hash_var;
  //all vars present and passwords match?
  if ($user_name && $password1 && $password1==$password2 && $email && validate_email($email)) {
    //password and name are valid?
    if (account_namevalid($user_name) && account_pwvalid($password1)) {
      $user_name=strtolower($user_name);
      $password1=strtolower($password1);
      
      //does the name exist in the database?
      $sql="SELECT * FROM user WHERE user_name='$user_name'";
      $result=db_query($sql);
      if ($result && db_numrows($result) > 0) {
	$feedback .=  "$lang[error_name_exists]";
	return false;
      }
      //does the email exist in the database?
      $sql="SELECT * FROM user WHERE email='$email'";
      $result=db_query($sql);
      if ($result && db_numrows($result) > 0) {
	$feedback .=  "$lang[error_email_exists]";
	return false;
      } else {
	//create a new hash to insert into the db and the confirmation email
	$hash=md5($email.$hidden_hash_var);
	$sql="INSERT INTO user (user_name,real_name,password,email,remote_addr,confirm_hash,is_confirmed) ".
	   "VALUES ('$user_name','$real_name','". md5($password1) ."','$email','$GLOBALS[REMOTE_ADDR]','$hash','0')";
	$result=db_query($sql);
	if (!$result) {
	  $feedback .= ' ERROR - '.db_error();
	  return false;
	} else {
	  //send the confirm email
	  user_send_confirm_email($email,$hash);
	  $feedback .= "$lang[reg_success_email_waiting]";
	  return true;
	}
      }
    } else {
      $feedback .=  "$lang[error_uname_or_pass_bad2]";
      return false;
    }
  } else {
    $feedback .=  "$lang[error_bad_input1]";
    return false;
  }
}

function user_getid() {
  global $G_USER_RESULT;
  //see if we have already fetched this user from the db, if not, fetch it
  if (!$G_USER_RESULT) {
    $G_USER_RESULT=db_query("SELECT * FROM user WHERE user_name='" . user_getname() . "'");
  }
  if ($G_USER_RESULT && db_numrows($G_USER_RESULT) > 0) {
    return db_result($G_USER_RESULT,0,'user_id');
  } else {
    return false;
  }
}

function user_getrealname() {
  global $G_USER_RESULT;
  //see if we have already fetched this user from the db, if not, fetch it
  if (!$G_USER_RESULT) {
    $G_USER_RESULT=db_query("SELECT * FROM user WHERE user_name='" . user_getname() . "'");
  }
  if ($G_USER_RESULT && db_numrows($G_USER_RESULT) > 0) {
    return db_result($G_USER_RESULT,0,'real_name');
  } else {
    return false;
  }
}

function user_getemail() {
  global $G_USER_RESULT;
  //see if we have already fetched this user from the db, if not, fetch it
  if (!$G_USER_RESULT) {
    $G_USER_RESULT=db_query("SELECT * FROM user WHERE user_name='" . user_getname() . "'");
  }
  if ($G_USER_RESULT && db_numrows($G_USER_RESULT) > 0) {
    return db_result($G_USER_RESULT,0,'email');
  } else {
    return false;
  }
}

function user_getname() {
  global $dicshunary_root_path, $lang;
  if (user_isloggedin()) {
    return $GLOBALS['user_name'];
  } else {
    //look up the user some day when we need it
    return "$error_not_logged_in";
  }
}

function account_pwvalid($pw) {
  global $feedback, $lang, $dicshunary_root_path;
  if (strlen($pw) < 6) {
    $feedback .= "$lang[pass_too_short]";
    return false;
  }
  return true;
}

function account_namevalid($name) {
  global $feedback, $lang, $dicshunary_root_path;
  // no spaces
  if (strrpos($name,' ') > 0) {
    $feedback .= "$lang[no_spaces_allowed]";
    return false;
  }
  
  // must have at least one character
  if (strspn($name,"abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ") == 0) {
    $feedback .= "$lang[need_one_character]";
    return false;
  }
  
  // must contain all legal characters
  if (strspn($name,"abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789-_")
      != strlen($name)) {
    $feedback .= "$lang[illegal_character]";
    return false;
  }
  
  // min and max length
  if (strlen($name) < 5) {
    $feedback .= "$lang[name_too_short]";
    return false;
  }
  if (strlen($name) > 15) {
    $feedback .= "$lang[name_too_long]";
    return false;
  }
  
  // illegal names
  if (eregi("^((root)|(bin)|(daemon)|(adm)|(lp)|(sync)|(shutdown)|(halt)|(mail)|(news)"
	    . "|(uucp)|(operator)|(games)|(mysql)|(httpd)|(nobody)|(dummy)"
	    . "|(www)|(cvs)|(shell)|(ftp)|(irc)|(debian)|(ns)|(download))$",$name)) {
    $feedback .= "$lang[name_is_reserved]";
    return 0;
  }
  if (eregi("^(anoncvs_)",$name)) {
    $feedback .= "$lang[name_is_reserved]";
    return false;
  }
  
  return true;
}

function validate_email ($address) {
  return (ereg('^[-!#$%&\'*+\\./0-9=?A-Z^_`a-z{|}~]+'. '@'. '[-!#$%&\'*+\\/0-9=?A-Z^_`a-z{|}~]+\.' . '[-!#$%&\'*+\\./0-9=?A-Z^_`a-z{|}~]+$', $address));
}

// new admin function

function user_isadmin() {
  global $UIA_RESULT;
  // get user_id
  $user_id = user_getid();
  //see if we have already fetched this from the db, if not, fetch it
  if (!$UIA_RESULT) {
    $UIA_RESULT=db_query("SELECT user_id FROM user WHERE user_id='$user_id' AND is_admin = 1");
  }
  if ($UIA_RESULT && db_numrows($UIA_RESULT) > 0) {
    return true;
  } else {
    return false;
  }
}

function user_isfirstadmin() {
  global $UIA_RESULT;
  // get user_id
  $user_id = user_getid();
  //see if we have already fetched this from the db, if not, fetch it
  if (!$UIA_RESULT) {
    $UIA_RESULT=db_query("SELECT user_id FROM user WHERE user_id='$user_id' AND is_admin = 1 AND user_id = 1");
  }
  if ($UIA_RESULT && db_numrows($UIA_RESULT) > 0) {
    return true;
  } else {
    return false;
  }
}


/// new functions added for the dicshunary, but they do fit in here.

function set_rudeness($set_rudeness) {
  if ($set_rudeness == 'show_me_the_filth') {
    setcookie('rudeness','rude',(time()+2592000),'/','',0);
    // update the db  - this user likes rudeness
    if ($user_id = user_getid()) {
      $sql="UPDATE user SET likes_rudeness = '1' WHERE user_id = '$user_id'";
      $result=db_query($sql);
      if (!$result) {
	$feedback .= ' ERROR - '.db_error();
	return false;
      } 
    }
    header("Location:$PHP_SELF");
    return true;
  } elseif ($set_rudeness == 'hide_naughty_words') {
    setcookie('rudeness','',(time()+2592000),'/','',0);
    // update the db  - this user does not like rudeness
    if ($user_id = user_getid()) {
      $sql="UPDATE user SET likes_rudeness = '0' WHERE user_id = '$user_id'";
      $result=db_query($sql);
      if (!$result) {
	$feedback .= ' ERROR - '.db_error();
	return false;
      } 
    }
    header("Location:$PHP_SELF");
    return true;
  }
}

function print_rudeness_selector() {
  global $rudeness, $lang, $phpEx;
  if ($rudeness == 'rude') {
    return '[ <a href="rudeness.'.$phpEx.'?set_rudeness=hide_naughty_words">'.$lang[hide_naughty_words].'</a> ]';
  } else {
    return '[ <a href="rudeness.'.$phpEx.'?set_rudeness=show_me_the_filth">'.$lang[show_me_the_filth].'</a> ]';
  }
}


function user_login_unident() {
  global $unident_name, $use_unident, $unident_pass, $PHP_SELF, $reload;
  // this function logs the user in as the default user ($unident_name).
  // first, we check if the unident user exists.
  user_login($unident_name, $unident_pass);
  if ($reload != 'true') {
    header("Location:$PHP_SELF?reload=true");
  }
  
}


?>
